import { LabeledComponent, ComponentDescriptor, ComponentExample, UIModel, LabelProperties } from '@ngx-dynamic-components/core';
export declare class InputUIComponent extends LabeledComponent<InputProperties> {
    readonly cssClasses: {
        invisible: boolean;
        required: boolean;
    };
    readonly inputStyles: {
        [key: string]: string;
    };
    readonly wrapperStyles: {
        height: string;
    };
    readonly name: string;
}
export declare class InputProperties extends LabelProperties {
    placeholder?: string;
    type?: string;
    enabled?: boolean;
    visible?: boolean;
    inputWidth?: string;
    inputHeight?: string;
    required?: boolean;
    minlength?: number;
    maxlength?: number;
    pattern?: string;
}
export declare const example: ComponentExample<UIModel<InputProperties>>;
interface InputUIComponentConstrutor {
    new (): InputUIComponent;
}
interface InputPropertiesConstrutor {
    new (): InputProperties;
}
export declare const inputDescriptor: ComponentDescriptor<InputUIComponentConstrutor, InputPropertiesConstrutor>;
export {};
