import { DoCheck } from '@angular/core';
import { LabelProperties, ComponentDescriptor, LabeledComponent, UIModel, ComponentExample, OptionValue } from '@ngx-dynamic-components/core';
export declare class SelectUIComponent extends LabeledComponent<SelectProperties> implements DoCheck {
    options: OptionValue[];
    onSelect(): void;
    readonly selectStyles: {
        height: string;
    };
    ngDoCheck(): void;
    readonly disabled: string;
}
export declare class SelectProperties extends LabelProperties {
    options: {
        label: string;
        value: string | number;
    }[];
    selectHeight?: string;
}
interface SelectUIComponentConstrutor {
    new (): SelectUIComponent;
}
interface SelectPropertiesConstrutor {
    new (): SelectProperties;
}
export declare const example: ComponentExample<UIModel<SelectProperties>>;
export declare const selectDescriptor: ComponentDescriptor<SelectUIComponentConstrutor, SelectPropertiesConstrutor>;
export {};
